using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Windows.Forms;

namespace IssueSyncfusionGGC
{
    // Binding Object
    public class MyTable : BindingList<MyRow>, ITypedList
    {
        #region ITypedList Members

        public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] listAccessors)
        {
            List<PropertyDescriptor> newList = new List<PropertyDescriptor>();
            PropertyDescriptorCollection coll = TypeDescriptor.GetProperties(typeof(MyRow));
            foreach (PropertyDescriptor prop in coll)
            {
                if (prop.IsBrowsable)
                    newList.Add(prop);
            }
            return new PropertyDescriptorCollection(newList.ToArray());
        }

        public string GetListName(PropertyDescriptor[] listAccessors)
        {
            return "MyTable";
        }

        protected override object AddNewCore()
        {
            object o = base.AddNewCore();
            MessageBox.Show("Item Count in BindingList: " + this.Count.ToString());
            return o;
        }

        #endregion
    }

    public class MyRow
    {
        public MyRow()
        {
            m_FirstName = String.Empty;
            m_LastName = String.Empty;
        }

        public MyRow(string firstName, string lastName)
        {
            m_FirstName = firstName;
            m_LastName = lastName;
        }

        private string m_FirstName;

        public string FirstName
        {
            get { return m_FirstName; }
            set { m_FirstName = value; }
        }

        private string m_LastName;

        public string LastName
        {
            get { return m_LastName; }
            set { m_LastName = value; }
        }

    }
}
