﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace IssueSyncfusionGGC
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            MyTable table = new MyTable();
            for (int i = 0; i < 10; i++)
            {
                MyRow a = new MyRow("test" + i.ToString(), "test");
                table.Add(a);
            }
            this.OptimizeGridSettings(this.gridGroupingControl1);
            this.gridGroupingControl1.DataSource = table;
        }
        /// <summary>
        /// Optimize the grid grouping control(virtual mode, double buffering etc.)
        /// </summary>
        /// <param name="grid">Instance of the grid grouping control</param>
        void OptimizeGridSettings(GridGroupingControl grid)
        {
            this.gridGroupingControl1.CounterLogic = EngineCounters.YAmount;
            this.gridGroupingControl1.AllowedOptimizations = EngineOptimizations.DisableCounters | EngineOptimizations.RecordsAsDisplayElements;
            this.gridGroupingControl1.UseDefaultsForFasterDrawing = true; // GDI interop drawing, FirstNRecords Summaries
            this.gridGroupingControl1.InvalidateAllWhenListChanged = false; // only paint modified cells
            this.gridGroupingControl1.InsertRemoveBehavior = GridListChangedInsertRemoveBehavior.ScrollWithImmediateUpdate;
            this.gridGroupingControl1.UpdateDisplayFrequency = 50; // update every number of ms (speciy 0 if Update should occur manually, 1 if immediately)
            this.gridGroupingControl1.TableControl.EnableDoubleBufferSurface(); // reduce flickering

            // Instruct grouping control not to access datasource through
            // CurrencyManager API and instead access list diretly. When set to
            // false you wil howver loose support for built-in CurrencyManager
            // synchronization.
            this.gridGroupingControl1.BindToCurrencyManager = false;

            this.gridGroupingControl1.Engine.AllowCacheStyles = true;
        }
    }
}
